Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 2808)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 2809)
@@ -27,8 +27,25 @@
 
 
+
 using namespace std;
 using namespace CHCDemoEngine;
 
 
+GLuint fbo;
+GLuint depthbuffer;
+GLuint colorbuffer;
+GLuint colorbuffer2;
+GLuint depthTex;
+GLuint colorTex;
+GLuint colorTex2;
+
+GLuint normalTex;
+
+GLuint fbo2;
+GLuint occlusionbuffer;
+GLuint occlusionTex;
+
+int texWidth2 = 512;
+int texHeight2 = 512;
 
 /// the renderable scene geometry
@@ -65,18 +82,24 @@
 RenderQueue *renderQueue = NULL;
 
-
 /// these values get scaled with the frame rate
-const float keyForwardMotion = 50.0f;
-const float keyRotation = 2.0f;
+const static float keyForwardMotion = 50.0f;
+const static float keyRotation = 2.0f;
+
 /// elapsed time in seconds
 double elapsedTime = 1.0f;
 double algTime = 1.0f;
 
-int winWidth = 1024;
-int winHeight = 768;
-float winAspectRatio = 1.0f;
+static int winWidth = 1024;
+static int winHeight = 768;
+static float winAspectRatio = 1.0f;
 
 double accumulatedTime = 1000;
 float fps = 1e3f;
+
+float myfar = 0;
+
+// rendertexture
+const static int texWidth = 2048;
+const static int texHeight = 2048;
 
 int renderedObjects = 0;
@@ -98,6 +121,9 @@
 
 // mouse navigation state
-int xEyeBegin, yEyeBegin, yMotionBegin = 0;
-int verticalMotionBegin, horizontalMotionBegin = 0;
+int xEyeBegin = 0;
+int yEyeBegin = 0;
+int yMotionBegin = 0;
+int verticalMotionBegin = 0;
+int horizontalMotionBegin = 0;
 
 bool useOptimization = false;
@@ -119,7 +145,13 @@
 
 
+static Vector3 samples[32];
+
+
+// function forward declarations
 void InitExtensions();
 void DisplayVisualization();
 void InitGLstate();
+void InitRenderTexture();
+void InitCg();
 void CleanUp();
 void SetupEyeView();
@@ -152,4 +184,5 @@
 
 void PlaceViewer(const Vector3 &oldPos);
+void DisplayRenderTexture();
 
 
@@ -157,15 +190,64 @@
 inline float KeyShift() { return keyForwardMotion * elapsedTime; }
 
+void InitFBO();
+
+void GenerateSamples();
+
+void ComputeViewVectors(Vector3 &tl, Vector3 &tr, Vector3 &bl, Vector3 &br);
+
+GLenum mrt[] = {GL_COLOR_ATTACHMENT0_EXT, GL_COLOR_ATTACHMENT1_EXT};
+
 
 // cg stuff
 static CGcontext sCgContext = NULL;
-static CGprogram sCgDepthPeelingProgram = NULL;
-static CGprogram sCgPassThroughProgram = NULL;
+static CGprogram sCgLinearDepthProgram = NULL;
+static CGprogram sCgSSAOProgram = NULL;
+static CGprogram sCgTestProgram = NULL;
 
 static CGprofile sCgFragmentProfile;
+static CGprofile sCgVertexProfile; 
+
 static CGparameter sTextureParam;
-static CGparameter sTexWidthParam; 
-static CGparameter sStepSizeParam;
-
+static CGparameter sSceneTextureParam;
+static CGparameter sNormalTextureParam;
+
+static CGparameter sTexSizeParam; 
+static CGparameter sSamplesParam; 
+static CGparameter sEyeVecParam; 
+static CGparameter sRadiusParam; 
+
+//static CGparameter sPositionParam;
+static CGparameter sModelViewMatrixParam;	
+static CGparameter sMaxDepthParam;
+
+const static float radius = 1e-3f;
+
+
+static void cgErrorCallback()
+{
+	CGerror lastError = cgGetError();
+
+	if(lastError)
+	{
+		printf("%s\n\n", cgGetErrorString(lastError));
+		printf("%s\n", cgGetLastListing(sCgContext));
+		printf("Cg error, exiting...\n");
+
+		exit(0);
+	}
+}
+
+
+static void PrintGLerror(char *msg)
+{
+	GLenum errCode;
+	const GLubyte *errStr;
+	
+	if ((errCode = glGetError()) != GL_NO_ERROR) 
+	{
+		errStr = gluErrorString(errCode);
+		fprintf(stderr,"OpenGL ERROR: %s: %s\n", errStr, msg);
+	}
+}
 
 
@@ -202,4 +284,6 @@
 	InitExtensions();
 	InitGLstate();
+	//InitRenderTexture();
+	InitFBO();
 
 	LeftMotion(0, 0);
@@ -240,4 +324,6 @@
 	//bvh = bvhLoader.Load("data/city/model/city.bvh", sceneEntities);
 
+	myfar = 10.0f * Magnitude(bvh->GetBox().Diagonal());
+
 	if (!bvh)
 	{
@@ -247,4 +333,5 @@
 	}
 
+	InitCg();
 
 	bvh->SetCamera(camera);
@@ -266,4 +353,214 @@
 
 	return 0;
+}
+
+
+void InitCg(void) 
+{
+	GenerateSamples();
+
+	// Setup Cg
+	cgSetErrorCallback(cgErrorCallback);
+
+	// Create cgContext.
+	sCgContext = cgCreateContext();
+
+	// get the best profile for this hardware
+	sCgFragmentProfile = cgGLGetLatestProfile(CG_GL_FRAGMENT);
+	//assert(sCgFragmentProfile != CG_PROFILE_UNKNOWN);
+	cgGLSetOptimalOptions(sCgFragmentProfile);
+
+	sCgVertexProfile = cgGLGetLatestProfile(CG_GL_VERTEX);
+	cgGLSetOptimalOptions(sCgVertexProfile);
+
+	sCgLinearDepthProgram = 
+		cgCreateProgramFromFile(sCgContext, 
+								CG_SOURCE,
+								"src/lineardepth.cg", 
+								sCgVertexProfile,
+								"main",
+								NULL);
+
+	if(sCgLinearDepthProgram != NULL)
+	{
+		cgGLLoadProgram(sCgLinearDepthProgram);
+	
+		sModelViewMatrixParam = cgGetNamedParameter(sCgLinearDepthProgram, "ModelViewProj");
+	}
+
+	sCgTestProgram = 
+		cgCreateProgramFromFile(sCgContext, 
+								CG_SOURCE,
+								"src/test2.cg", 
+								sCgFragmentProfile,
+								"main",
+								NULL);
+
+	if(sCgTestProgram != NULL)
+	{
+		cgGLLoadProgram(sCgTestProgram);
+
+		sMaxDepthParam = cgGetNamedParameter(sCgTestProgram, "maxDepth");
+		cgGLSetParameter1f(sMaxDepthParam, 1.0f / myfar);
+	}
+	else
+		cerr << "test program failed to load" << endl;
+
+	PrintGLerror("test");
+
+
+	///////////////
+
+	sCgSSAOProgram = 
+		cgCreateProgramFromFile(sCgContext, 
+								CG_SOURCE,
+								"src/ssao.cg", 
+								//"src/test.cg", 
+								sCgFragmentProfile,
+								NULL,
+								NULL);
+
+	if(sCgSSAOProgram != NULL)
+	{
+		cgGLLoadProgram(sCgSSAOProgram);
+
+		// we need size of texture for scaling
+		sTextureParam = cgGetNamedParameter(sCgSSAOProgram, "lindepth");  
+		sSceneTextureParam = cgGetNamedParameter(sCgSSAOProgram, "scene");  
+		sNormalTextureParam = cgGetNamedParameter(sCgSSAOProgram, "normal");  
+		sTexSizeParam = cgGetNamedParameter(sCgSSAOProgram, "invTexSize");
+		sRadiusParam = cgGetNamedParameter(sCgSSAOProgram, "radius");
+		sEyeVecParam = cgGetNamedParameter(sCgSSAOProgram, "eyevec");
+		sSamplesParam = cgGetNamedParameter(sCgSSAOProgram, "samples");
+
+		cgGLSetParameter1f(sTexSizeParam, 1.0f / (float)texWidth);
+		cgGLSetParameter1f(sRadiusParam, radius);
+		cgGLSetParameterArray3f(sSamplesParam, 0, 32, (const float *)samples);
+	}
+	else
+		cerr << "ssao program failed to load" << endl;
+
+	PrintGLerror("init");
+}
+
+
+void PrintFBOStatus(GLenum status)
+{
+	switch(status)
+	{
+	case GL_FRAMEBUFFER_COMPLETE_EXT:
+		cout << "frame buffer object created successfully" << endl;
+		break;
+	case GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT:
+		cerr << "incomplete attachment" << endl;
+		break;
+	case GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT:
+		cerr << "missing attachment" << endl;
+		break;
+	case GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT:
+		cerr << "incomplete dimensions" << endl;
+		break;
+	case GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT:
+		cerr << "incomplete formats" << endl;
+		break;
+	case GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT:
+		cerr << "incomplete draw buffer" << endl;
+		break;
+	case GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT:
+		cerr << "incomplete read buffer" << endl;
+		break;
+	case GL_FRAMEBUFFER_UNSUPPORTED_EXT:
+		cerr << "framebuffer unsupported" << endl;
+		break;
+	default:
+		cerr << "unknown status code " << status << endl;
+	}
+}
+
+
+void InitFBO()
+{	
+	glGenFramebuffersEXT(1, &fbo);
+	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fbo);
+
+	// create color buffer
+	int samples = 8;
+
+	glGenRenderbuffersEXT(1, &colorbuffer);
+	//glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_RGBA16F_ARB, texWidth, texHeight);
+	glRenderbufferStorageMultisampleEXT(GL_RENDERBUFFER_EXT, samples, GL_FLOAT_RGBA_NV, texWidth, texHeight);
+	glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, colorbuffer);
+	glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_RENDERBUFFER_EXT, colorbuffer);
+
+	glGenTextures(1, &colorTex);
+	glBindTexture(GL_TEXTURE_2D, colorTex);
+	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16F_ARB,  texWidth, texHeight, 0, GL_RGBA, GL_FLOAT, NULL);
+	glGenerateMipmapEXT(GL_TEXTURE_2D);
+	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_TEXTURE_2D, colorTex, 0);
+
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
+
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
+
+	PrintFBOStatus(glCheckFramebufferStatusEXT(GL_FRAMEBUFFER_EXT));
+
+
+	glGenRenderbuffersEXT(1, &colorbuffer2);
+	glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_RGBA16F_ARB, texWidth, texHeight);
+	glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, colorbuffer2);
+	glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT1_EXT, GL_RENDERBUFFER_EXT, colorbuffer2);
+
+	glGenTextures(1, &colorTex2);
+	glBindTexture(GL_TEXTURE_2D, colorTex2);
+	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16F_ARB,  texWidth, texHeight, 0, GL_RGBA, GL_FLOAT, NULL);
+	glGenerateMipmapEXT(GL_TEXTURE_2D);
+	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT1_EXT, GL_TEXTURE_2D, colorTex2, 0);
+
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
+
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
+	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
+
+	PrintFBOStatus(glCheckFramebufferStatusEXT(GL_FRAMEBUFFER_EXT));
+
+	///////////
+	// create depth buffer
+
+	glGenRenderbuffersEXT(1, &depthbuffer);	
+	glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, depthbuffer);
+	glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT, texWidth, texHeight);
+	glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, depthbuffer);
+
+	
+	PrintFBOStatus(glCheckFramebufferStatusEXT(GL_FRAMEBUFFER_EXT));
+	
+	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
+
+
+	////////////////
+	//-- second fbo
+
+	/*glGenFramebuffersEXT(1, &fbo2);
+	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fbo2);
+
+	// create color buffer
+	glGenRenderbuffersEXT(1, &occlusionbuffer);
+	//glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_RGBA16F_ARB, texWidth, texHeight);
+	glRenderbufferStorageMultisampleEXT(GL_RENDERBUFFER_EXT, samples, GL_FLOAT_RGBA_NV, texWidth2, texHeight2);
+	glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, occlusionbuffer);
+	glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_RENDERBUFFER_EXT, occlusionbuffer);
+
+	glGenTextures(1, &occlusionTex);
+	glBindTexture(GL_TEXTURE_2D, occlusionTex);
+	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16F_ARB,  texWidth2, texHeight2, 0, GL_RGBA, GL_FLOAT, NULL);
+	glGenerateMipmapEXT(GL_TEXTURE_2D);
+	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_TEXTURE_2D, colorTex, 0);
+
+	PrintFBOStatus(glCheckFramebufferStatusEXT(GL_FRAMEBUFFER_EXT));
+
+	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);*/
 }
 
@@ -470,5 +767,5 @@
 	glLoadIdentity();
 
-	gluPerspective(fov, 1.0f / winAspectRatio, nearDist, 10.0f * Magnitude(bvh->GetBox().Diagonal()));
+	gluPerspective(fov, 1.0f / winAspectRatio, nearDist, myfar);
 
 	glMatrixMode(GL_MODELVIEW);
@@ -535,4 +832,17 @@
 	algTimer.Start();
 
+	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fbo);
+	
+	glPushAttrib(GL_VIEWPORT_BIT);
+	glViewport(0, 0, texWidth, texHeight);
+
+	cgGLEnableProfile(sCgFragmentProfile);
+	cgGLBindProgram(sCgTestProgram);
+
+	cgGLEnableProfile(sCgVertexProfile);
+	cgGLBindProgram(sCgLinearDepthProgram);
+
+	glDrawBuffers(2, mrt);
+	
 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 
@@ -556,4 +866,11 @@
 	SetupEyeView();
 
+	Vector3 dir =  camera->GetDirection();
+	cgGLSetParameter3f(sEyeVecParam, dir.x, dir.y, dir.z);
+
+	// set modelview matrix for shaders
+	cgGLSetStateMatrixParameter(sModelViewMatrixParam, CG_GL_MODELVIEW_PROJECTION_MATRIX, CG_GL_MATRIX_IDENTITY);
+	cgGLEnableProfile(sCgVertexProfile);
+
 	// actually render the scene geometry using one of the specified algorithms
 	traverser->RenderScene();
@@ -561,5 +878,5 @@
 
 	//////
-	//-- other rendering
+	//-- do the rest of the rendering
 
 	glEnableClientState(GL_VERTEX_ARRAY);
@@ -583,4 +900,14 @@
 	glDisableClientState(GL_VERTEX_ARRAY);
 	glDisableClientState(GL_NORMAL_ARRAY);
+	
+	
+	cgGLDisableProfile(sCgVertexProfile);
+	cgGLDisableProfile(sCgFragmentProfile);
+
+	glPopAttrib();
+	
+	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
+
+	DisplayRenderTexture();
 
 	if (useGlFinish) glFinish();
@@ -836,5 +1163,5 @@
 	glLoadIdentity();
 
-	gluPerspective(fov, 1.0f / winAspectRatio, nearDist, 10.0f * Magnitude(bvh->GetBox().Diagonal()));
+	gluPerspective(fov, 1.0f / winAspectRatio, nearDist, myfar);
 
 	glMatrixMode(GL_MODELVIEW);
@@ -1071,4 +1398,11 @@
 	DEL_PTR(loader);
 	DEL_PTR(renderQueue);
+
+	if (sCgLinearDepthProgram)
+		cgDestroyProgram(sCgLinearDepthProgram);
+	if (sCgSSAOProgram)
+		cgDestroyProgram(sCgSSAOProgram);
+	if (sCgContext)
+		cgDestroyContext(sCgContext);
 }
 
@@ -1232,2 +1566,197 @@
 	}
 }
+
+
+void DisplayRenderTexture2()
+{
+	glEnable(GL_TEXTURE_2D);
+	glBindTexture(GL_TEXTURE_2D, occlusionTex);
+
+	glDisable(GL_LIGHTING);
+
+	glMatrixMode(GL_PROJECTION);
+	glPushMatrix();
+	glLoadIdentity();
+
+	glMatrixMode(GL_MODELVIEW);
+	glPushMatrix();
+	glLoadIdentity();
+	
+	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fbo2);
+	glPushAttrib(GL_VIEWPORT_BIT);
+	glViewport(0, 0, texWidth2, texHeight2);
+
+	glOrtho(-0.5f, 0.5f, -0.5f, 0.5f, 0, 1);
+
+	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
+	
+	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+
+	glColor3f(1.0f, 1.0f, 1.0f);
+
+	glBegin(GL_QUADS);
+	glTexCoord2f(0, 0); glVertex3f(-1, -1, -0.5f);
+	glTexCoord2f(1, 0); glVertex3f( 1, -1, -0.5f);
+	glTexCoord2f(1, 1); glVertex3f( 1,  1, -0.5f);
+	glTexCoord2f(0, 1); glVertex3f(-1,  1, -0.5f);
+	glEnd();
+
+	glEnable(GL_LIGHTING);
+	glDisable(GL_TEXTURE_2D);
+	
+	glMatrixMode(GL_PROJECTION);
+	glPopMatrix();
+
+	glMatrixMode(GL_MODELVIEW);
+	glPopMatrix();
+
+	glPopAttrib();
+	glBindTexture(GL_TEXTURE_2D, 0);
+
+	PrintGLerror("displaytexture2");
+}
+
+void DisplayRenderTexture()
+{
+	glDisable(GL_TEXTURE_2D);
+	glDisable(GL_LIGHTING);
+
+	glMatrixMode(GL_PROJECTION);
+	glPushMatrix();
+	glLoadIdentity();
+
+	glMatrixMode(GL_MODELVIEW);
+	glPushMatrix();
+	glLoadIdentity();
+	
+	/*glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fbo2);
+	glPushAttrib(GL_VIEWPORT_BIT);
+	glViewport(0, 0, texWidth2, texHeight2);
+*/
+	glOrtho(-0.5f, 0.5f, -0.5f, 0.5f, 0, 1);
+	
+	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+
+	cgGLEnableProfile(sCgFragmentProfile);
+	cgGLBindProgram(sCgSSAOProgram);
+
+	cgGLEnableTextureParameter(sTextureParam);
+	cgGLSetTextureParameter(sTextureParam, colorTex2);
+	
+	cgGLEnableTextureParameter(sSceneTextureParam);
+	cgGLSetTextureParameter(sSceneTextureParam, colorTex);
+	
+	cgGLEnableTextureParameter(sNormalTextureParam);
+	cgGLSetTextureParameter(sNormalTextureParam, normalTex);
+
+	Vector3 tl, tr, bl, br;
+	ComputeViewVectors(tl, tr, bl, br);
+
+	glColor3f(1.0f, 1.0f, 1.0f);
+
+	glBegin(GL_QUADS);
+#if 1
+	glColor3f(bl.x, bl.y, bl.z); glTexCoord2f(0, 0); glVertex3f(-1, -1, -0.5f);
+	glColor3f(br.x, br.y, br.z); glTexCoord2f(1, 0); glVertex3f( 1, -1, -0.5f);
+	glColor3f(tr.x, tr.y, tr.z); glTexCoord2f(1, 1); glVertex3f( 1,  1, -0.5f);
+	glColor3f(tl.x, tl.y, tl.z); glTexCoord2f(0, 1); glVertex3f(-1,  1, -0.5f);
+#else
+	glTexCoord2f(0, 0); glVertex3f(-1, -1, -0.5f);
+	glTexCoord2f(1, 0); glVertex3f( 1, -1, -0.5f);
+	glTexCoord2f(1, 1); glVertex3f( 1,  1, -0.5f);
+	glTexCoord2f(0, 1); glVertex3f(-1,  1, -0.5f);
+#endif
+	glEnd();
+
+	cgGLDisableTextureParameter(sTextureParam);
+	cgGLDisableTextureParameter(sSceneTextureParam);
+	cgGLDisableProfile(sCgFragmentProfile);
+	
+	glEnable(GL_LIGHTING);
+	glDisable(GL_TEXTURE_2D);
+	
+	glMatrixMode(GL_PROJECTION);
+	glPopMatrix();
+
+	glMatrixMode(GL_MODELVIEW);
+	glPopMatrix();
+
+	//glPopAttrib();
+	//glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fbo2);
+
+	PrintGLerror("displaytexture");
+	//DisplayRenderTexture2();
+}
+
+
+
+void GenerateSamples()
+{
+	// fill an n * n * 2 array with uniformly distributed spherical samples
+	for (int i = 0; i < 32; ++ i)
+	{
+		// create stratified samples over sphere
+		const float rx = RandomValue(0, 1);
+		const float ry = RandomValue(0, 1);
+		//const float l = RandomValue(0, 1);
+
+		const float theta = 2.0f * acos(sqrt(1.0f - rx));
+		const float phi = 2.0f * M_PI * ry;
+
+		samples[i] = Vector3(sin(theta) * cos(phi), sin(theta) * sin(phi), cos(theta));
+		cout << samples[i] << endl;
+	}
+}
+
+
+void ComputeViewVectors(Vector3 &tl, Vector3 &tr, Vector3 &bl, Vector3 &br)
+{
+	float myfov = fov * M_PI / 180.0f;
+	const float h_far = 2.0f * tan(myfov / 2.0f);
+	const float w_far = h_far * texWidth / texHeight;
+
+	float t1 = h_far * 0.5f;
+	float t2 = w_far * 0.5f;
+
+	bl = Normalize(Vector3(-t1, -t2, 1.0f));
+	br = Normalize(Vector3( t1, -t2, 1.0f));
+	tl = Normalize(Vector3(-t1,  t2, 1.0f));
+	tr = Normalize(Vector3( t1,  t2, 1.0f));
+
+	// normalize to 0 .. 1
+	bl = bl * 0.5f + 0.5f;
+	br = br * 0.5f + 0.5f;
+	tl = tl * 0.5f + 0.5f;
+	tr = tr * 0.5f + 0.5f;
+
+/*
+	cout << "tl: " << tl << endl;
+	cout << "tr: " << tr << endl;
+	cout << "bl: " << bl << endl;
+	cout << "br: " << bl << endl << endl;*/
+}
+
+
+void CreateNormalMap()
+{
+	Vector3 *data = new Vector3[texWidth * texHeight];
+
+	for (int i = 0; i < texWidth * texHeight; ++ i)
+	{
+		// create random samples over sphere
+		const float rx = RandomValue(0, 1);
+		const float ry = RandomValue(0, 1);
+
+		const float theta = 2.0f * acos(sqrt(1.0f - rx));
+		const float phi = 2.0f * M_PI * ry;
+
+		data[i] = Vector3(sin(theta) * cos(phi), sin(theta) * sin(phi), cos(theta));
+		data[i] += 1.0f;	
+		data[i] *= 0.5f;
+	}
+
+	glGenTextures(1, &normalTex);
+	glBindTexture(GL_TEXTURE_2D, normalTex);
+	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8,  texWidth, texHeight, 0, GL_RGB, GL_UNSIGNED_BYTE, data);
+}
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/linearDepth.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/linearDepth.cg	(revision 2809)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/linearDepth.cg	(revision 2809)
@@ -0,0 +1,35 @@
+// input
+struct appdata 
+{
+    float4 pos: POSITION;
+    float4 color: COLOR0;
+    float4 texCoord: TEXCOORD0;
+};
+
+
+// output
+
+struct vfconn
+{
+     float4 pos	: POSITION;
+     float4 color0: COLOR0;
+     float4 texCoord0: TEXCOORD0; 
+     float4 lindepth: TEXCOORD1; 
+};
+
+
+vfconn main(appdata IN,	uniform float4x4 ModelViewProj)
+{
+   vfconn OUT;
+  
+   // Transform The Vertex Position Into Homogenous Clip-Space (Required)
+   OUT.pos = mul(ModelViewProj, IN.pos);
+
+   OUT.color0 = IN.color;
+   //OUT.color0[1] = 1.0f;
+
+   OUT.texCoord0 = IN.texCoord;
+   OUT.lindepth = OUT.pos;
+
+   return OUT;
+}
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/test.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/test.cg	(revision 2809)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/test.cg	(revision 2809)
@@ -0,0 +1,27 @@
+struct fragment
+{
+      float4 position  : POSITION; // screen position
+      float4 color0    : COLOR0;
+      float4 texCoord: TEXCOORD0;
+};
+
+
+struct pixel
+{
+      float4 color : COLOR;	
+};
+
+
+pixel main(fragment IN, 
+           const uniform sampler2D tex, 
+           const uniform sampler2D depthTex)
+{
+      pixel OUT;
+      //OUT.color = IN.color0;
+	
+      float4 col = tex2D(tex, IN.texCoord.xy) * 0.01;
+      col += tex2D(depthTex, IN.texCoord.xy).x * 0.5;
+      OUT.color = col;
+	
+      return OUT;
+}
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/test2.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/test2.cg	(revision 2809)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/test2.cg	(revision 2809)
@@ -0,0 +1,27 @@
+struct fragment
+{
+      float4 pos: WPOS; // world position
+      float4 color0  : COLOR0;
+      float4 texCoord: TEXCOORD0;      
+      float4 lindepth: TEXCOORD1;
+};
+
+
+struct pixel
+{
+      float4 color0: COLOR0;
+      float4 color1: COLOR1;
+};
+
+
+pixel main(fragment IN, uniform sampler2D tex, uniform float maxDepth)
+//pixel main(fragment IN, uniform sampler2D tex)
+{
+     pixel pix;
+      
+     pix.color0 = IN.color0 * tex2D(tex, IN.texCoord.xy);
+     pix.color1 = IN.lindepth.z * maxDepth;// * IN.pos.z / IN.pos.w;
+    // pix.color1.w = 1;
+
+     return pix;
+}
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg	(revision 2809)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg	(revision 2809)
@@ -0,0 +1,88 @@
+struct fragment
+{
+    float4 pos: WPOS; // normalized screen position
+    float4 view: COLOR;
+    float4 texcoord: TEXCOORD0;      
+    float4 lindepth: TEXCOORD1;
+};
+
+
+struct pixel
+{
+    float4 col: COLOR0;
+};
+
+
+float3 reflect(float3 pt, float3 n)
+{
+  // distance to plane
+  float d = dot(n, pt);
+  // reflect around plane
+  float3 rpt = pt - d * 2.0f * n;
+  
+  //return pt;
+  return rpt;
+}
+
+
+pixel main(fragment IN, 
+           uniform sampler2D lindepth,
+           uniform sampler2D scene,
+           uniform sampler2D normal,
+           uniform float invTexSize,
+           uniform float radius,
+	   uniform float3 eyevec,
+	   uniform float3 samples[32])
+{
+    pixel OUT;
+ 
+    // eye space z
+    float eyez = tex2D(lindepth, IN.texcoord.xy).x;
+
+    float3 viewvec = IN.view.xyz * 2.0f - float3(1.0f);
+    viewvec /= viewvec.z;
+
+    //return float4(viewvec.xyz, 1.0f);
+    // eye point
+    //float3 eyept = eyez * viewvec;
+    float3 eyept = float3(IN.texcoord.xy, eyez);
+
+    float4 pl = tex2D(normal, IN.pos.xy * invTexSize);
+    pl = pl * 2.0 - float4(1.0);
+
+    float occlusion = 0.0;
+
+    // gather occlusion from surrounding samples
+    for (int i = 0; i < 32; i ++)
+    {
+        // generate new sample point
+        //float3 samplepos = eyept + radius * samples[i];
+        // create some dithering by reflecting the sample point alond some random plane
+        float3 samplepos = eyept + radius * reflect(samples[i], pl.xyz);
+
+        // project to texture space q: why the scaling?
+        float2 sampletex = (samplepos.xy / samplepos.z);// * float2(0.75, 1.0);
+        
+        //float2 sampletexn = sampletex;
+	// normalize to [0 .. 1], move eye point to center
+	//float2 sampletexn = sampletex * 0.5f + float2(0.5f);
+        float2 sampletexn = sampletex + float2(0.5f);
+
+        // look up depth at sample point
+        float depth = tex2D(lindepth, sampletexn).x;
+        // compare: is point occluded?
+        //float zdist = 50.0f * max(-samplepos.z + depth, 0.0f);
+	float zdist = 50.0f * max(samplepos.z - depth, 0.0f);
+        // occlusion factor shrinks quadratic with distance to occluder
+	occlusion += 1.0 / (1.0 + zdist * zdist);
+	//occlusion += 1.0 / (1.0 + zdist);
+   }
+
+   // normalize
+   occlusion /= 32.0f;
+  
+   OUT.col = 1.0f - occlusion;
+   //   OUT.col = tex2D(scene, IN.texcoord.xy) * 0.5 + (1.0f - occlusion);
+
+   return OUT;
+}
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneQuery.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneQuery.cpp	(revision 2808)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneQuery.cpp	(revision 2809)
@@ -12,20 +12,7 @@
 using namespace std;
 
-int texWidth = 2048;
-int texHeight = 2048;
+static int texWidth = 2048;
+static int texHeight = 2048;
 
-/*static void cgErrorCallback()
-{
-	CGerror lastError = cgGetError();
-
-	if(lastError)
-	{
-		printf("%s\n\n", cgGetErrorString(lastError));
-		printf("%s\n", cgGetLastListing(sCgContext));
-		printf("Cg error, exiting...\n");
-
-		exit(0);
-	}
-}*/
 
 
@@ -137,15 +124,4 @@
 	cout << "Preparing scene queries" << endl;
 
-	RenderTexture *depthTexture = new RenderTexture(texWidth, texHeight, true, true);
-
-#ifdef ATI
-	depthTexture->Initialize(true, true, false, false, false, 8, 8, 8, 8, RenderTexture::RT_COPY_TO_TEXTURE);
-#else
-	depthTexture->Initialize(true, true, false, false, false, 8, 8, 8, 8);//, RenderTexture::RT_COPY_TO_TEXTURE);
-#endif
-
-	PrintGLerror("Init");
-
-
 	const float xlen = mSceneBox.Size().x * 0.5f;
 	const float ylen = mSceneBox.Size().y * 0.5f;
@@ -160,34 +136,43 @@
 	orthoCam->SetPosition(pos);
 
+	RenderTexture *depthTexture = new RenderTexture(texWidth, texHeight, true, true);
+
+#ifdef ATI
+	depthTexture->Initialize(true, true, false, false, false, 8, 8, 8, 8, RenderTexture::RT_COPY_TO_TEXTURE);
+#else
+	depthTexture->Initialize(true, true, false, false, false, 8, 8, 8, 8);//, RenderTexture::RT_COPY_TO_TEXTURE);
+#endif
+
+	PrintGLerror("Init");
+
 	depthTexture->BeginCapture();
+	{
+		glViewport(0, 0, texWidth, texHeight);
 
-	glViewport(0, 0, texWidth, texHeight);
+		glClearColor(1, 1, 1, 1);
+		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 
-	glClearColor(1, 1, 1, 1);
-	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+		glFrontFace(GL_CCW);
+		glCullFace(GL_BACK);
 
-	glFrontFace(GL_CCW);
-	glCullFace(GL_BACK);
+		glEnable(GL_CULL_FACE);
 
-	glDisable(GL_CULL_FACE);
-	//glEnable(GL_CULL_FACE);
+		glShadeModel(GL_FLAT);
+		glEnable(GL_DEPTH_TEST);
 
-	glShadeModel(GL_FLAT);
-	glEnable(GL_DEPTH_TEST);
+		glMatrixMode(GL_PROJECTION);
+		glLoadIdentity();
 
-	glMatrixMode(GL_PROJECTION);
-	glLoadIdentity();
-	
-	glOrtho(-xlen, xlen, -ylen, ylen, 0.0f, mSceneBox.Size().z); 
-	
-	glMatrixMode(GL_MODELVIEW);
-	
-	orthoCam->SetupCameraView();
+		glOrtho(-xlen, xlen, -ylen, ylen, 0.0f, mSceneBox.Size().z); 
 
-	mDepth = new float[texHeight * texWidth];
+		glMatrixMode(GL_MODELVIEW);
 
-	//renderer->SetCamera(orthoCam);
-	renderer->RenderScene();
+		orthoCam->SetupCameraView();
 
+		mDepth = new float[texHeight * texWidth];
+
+		//renderer->SetCamera(orthoCam);
+		renderer->RenderScene();
+	}
 	depthTexture->EndCapture();
 
